<?php 
	// 
	// Provides receipt of weather data from custom CGI to the server and stores in a simple file. Has to be a server side 
	// script but theoretically need not be PHP. Other options are Perl CGI, Python, etc - depending upon 
	// what your web server supports.
	//
	// We assume security of the username/password is not critical (sent as plain text). We limit what
	// data we accept and try to ensure all sequences from the GET are properly stripped before use 
	// on a web page. 
	//
	// We use a GET rather than POST since data is very limited and doesn't overly affect server operation.
	//
	$success = 0;
	$line_end = "<br>\r\n";
	if(htmlspecialchars($_GET['action']) === 'update') // what do we want to do?
	{
		if(htmlspecialchars($_GET['ID']) === 'joeblog')	// the user name allowed to update the data (***CHANGE THIS!***)
		{
			if(htmlspecialchars($_GET['PASSWORD']) === 'xxxxxx')	// the password of that user (***CHANGE THIS!***)
			{
				$output = "";
				$output .= "Date (UTC): " . htmlspecialchars($_GET['dateutc']) . $line_end; // 2023-03-20+1117%3A01%3A17
				$output .= "Wind dir (deg): " . (float)($_GET['winddir']) . $line_end; // 230
				$output .= "Wind Speed (mph): " . (float)($_GET['windspeedmph']) . $line_end; //12
				$output .= "Wind Speed (mphAv10mins): " . (float)($_GET['windspeedmphav_10m']) . $line_end; //12
				$output .= "Wind Gust (mph): " . (float)($_GET['windgustmph']) . $line_end; // 12
				$output .= "Wind Gust (dir): " . (float)($_GET['windgustdir']) . $line_end; // 127
				$output .= "Wind Gust (mph10mins): " . (float)($_GET['windgustmph_10m']) . $line_end; // 12
				$output .= "Wind Gust (dir10mins): " . (float)($_GET['windgustdir_10m']) . $line_end; // 12
				$output .= "Humidity: " . (float)($_GET['humidity']) . $line_end; // 90
				$output .= "Dew Point (F): " . (float)($_GET['dewptf']) . $line_end; // 68.2
				$output .= "Temp (F): " . (float)($_GET['tempf']) . $line_end; // 12
				$output .= "Rain/h (in): " . (float)($_GET['raininch']) . $line_end; // 0
				$output .= "Rain (Daily) (in): " . (float)($_GET['rain24hinch']) . $line_end; // 0
				$output .= "Barom (in): " . (float)($_GET['baroinch']) . $line_end; // 29.1
				$output .= "Internal Temp (F): " . (float)($_GET['itempf']) . $line_end; // 60.2
				$output .= "Internal Humidity: " . (float)($_GET['ihumidity']) . $line_end; // 51
				$output .= "Solar Radiation (W/m2): " . (float)($_GET['solarradiation']) . $line_end; // 312
				$output .= "UV: " . (float)($_GET['UV']) . $line_end; // 312

				$output .= "Barom 3hr delta (in): " . (float)($_GET['baro3hrinch']) . $line_end; // 0.012

				$output .= "Hi Temp (F): " . (float)($_GET['hitemp']) . $line_end; // 12
				$output .= "Hi Temp (Time): " . htmlspecialchars($_GET['hitempt']) . $line_end; // 12%3A32%3A00
				$output .= "Lo Temp (F): " . (float)($_GET['lotemp']) . $line_end; // 12
				$output .= "Lo Temp (Time): " . htmlspecialchars($_GET['lotempt']) . $line_end; // 12%3A32%3A00


				$output .= "Hi Dew Point (F): " . (float)($_GET['hidewptf']) . $line_end; // 45
				$output .= "Hi Dew Point (Time): " . htmlspecialchars($_GET['hidewptt']) . $line_end; // 12%3A32%3A00
				$output .= "Lo Dew Point (F): " . (float)($_GET['lodewptf']) . $line_end; // 12
				$output .= "Lo Dew Point (Time): " . htmlspecialchars($_GET['lodewptt']) . $line_end; // 12%3A32%3A00


				$output .= "Hi Humidity: " . (float)($_GET['hihum']) . $line_end; // 82
				$output .= "Hi Humidity (Time): " . htmlspecialchars($_GET['hihumt']) . $line_end; // 12%3A32%3A00
				$output .= "Lo Humidity: " . (float)($_GET['lohum']) . $line_end; // 56
				$output .= "Lo Humidity (Time): " . htmlspecialchars($_GET['lohumt']) . $line_end; // 12%3A32%3A00


				$output .= "Hi Barom (in): " . (float)($_GET['hibaroinch']) . $line_end; // 29.762
				$output .= "Hi Barom (Time): " . htmlspecialchars($_GET['hibarot']) . $line_end; // 12%3A32%3A00
				$output .= "Lo Barom (in): " . (float)($_GET['lobaroinch']) . $line_end; // 28.123
				$output .= "Lo Barom (Time): " . htmlspecialchars($_GET['lobarot']) . $line_end; // 12%3A32%3A00

				$output .= "Hi Windspeed (mph): " . (float)($_GET['hiwindspeedmph']) . $line_end; // 12
				$output .= "Hi Windspeed (Time): " . htmlspecialchars($_GET['hiwindspeedt']) . $line_end; // 12%3A32%3A00


				$output .= "Hi Solar (W/m^2): " . (float)($_GET['hisolar']) . $line_end; // 127
				$output .= "Hi Solar (Time): " . htmlspecialchars($_GET['hisolart']) . $line_end; // 12%3A32%3A00

				$output .= "Hi UV: " . (float)($_GET['hiuv']) . $line_end; // 12
				$output .= "Hi UV (Time): " . htmlspecialchars($_GET['hiuvt']) . $line_end; // 12%3A32%3A00


				//echo $output;		// for testing
				
				if(($handle = fopen("weather_data.txt","wb")) !== FALSE)
				{
				    $write_status = fwrite($handle, $output);	// we ignore write status (FALSE on fail or bytes written)
					$close_status = fclose($handle);			// we ignore close status (FALSE failure, TRUE on success)
				    $success = 1;
				}
			}
		}
	}
	if($success==0)
	{
		echo 'Fail';
	}
	else
	{
		echo 'OK';
	}
?> 

